var data = {
    '1': {
        lastGPSFull: {
            lon: 0,
            lat: 0
        },
        history: [
            {
                time: Date.now(),
                lon: 5.7640,
                lat: 45.1899
            },
            {
                time: Date.now() - 5000,
                lon: 5.7642,
                lat: 45.1897
            },
            {
                time: Date.now() - 10000,
                lon: 5.7643,
                lat: 45.1887
            },
            {
                time: Date.now() - 15000,
                lon: 5.7644,
                lat: 45.1889
            }
        ]
    },
    '2': {
        lastGPSFull: {
            lon: 0,
            lat: 0
        },
        history: [
            {
                time: Date.now() - 1000,
                lon: 5.7644,
                lat: 45.1895
            },
            {
                time: Date.now() - 6000,
                lon: 5.7646,
                lat: 45.1893
            }
        ]
    }
};

var lastBroadcast = [];


module.exports.points = {
    getPoints: function () {
        return data;
    },
    addPointRaw: function(identifier, lon, lat) {
        if (!data[identifier])
            return;

        data[identifier].history.unshift({
            time: Date.now(),
            lon: lon,
            lat: lat
        });
        if (data[identifier].history.length >= 10)
            data[identifier].history.pop();
    },
    addPointFull: function(identifier, lonFull, latFull) {
        if (!data[identifier])
            data[identifier] = {
                lastGPSFull: {lon: 0, lat: 0},
                history: []
            };

        data[identifier].lastGPSFull = { lon: lonFull, lat: latFull };
        this.addPointRaw(identifier, lonFull, latFull);
    },
    addPointRelative: function(identifier, lonRel, latRel) {
        if (!data[identifier])
            return;

        let lastFull = data[identifier].lastGPSFull;
        this.addPointRaw(identifier, lastFull.lon + lonRel, lastFull.lat + latRel);
    }
}

/*
module.exports.points.addPointFull('test', 5.7644, 45.1893);
module.exports.points.addPointRelative('test', 0.0004, -0.0012);
module.exports.points.addPointRelative('test', 0.0004, -0.0015);
module.exports.points.addPointRelative('test', 0.0004, -0.0017);
module.exports.points.addPointRelative('test', 0.0004, -0.0020);
module.exports.points.addPointRelative('test', 0.0006, -0.0022);
*/

module.exports.broadcast = {
    savePacketByIdentifier: function(packetId) {
        lastBroadcast[packetId] = new Date()
    },
    canSendPacketByIdentifier: function(packetId) {
        if (!lastBroadcast[packetId])
            return true;
        return getMinutesBetweenDates(lastBroadcast[packetId], new Date()) >= 5
    }
}

function getMinutesBetweenDates(startDate, endDate) {
    return (endDate.getTime() - startDate.getTime()) / 60000;
}
